package cn.com.qmth.examcloud.core.oe.admin.api.provider;

import cn.com.qmth.examcloud.core.oe.admin.api.SyncExamDataCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamStudentBeanConvert;
import cn.com.qmth.examcloud.core.oe.admin.api.request.SyncExamDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.response.SyncExamDataResp;
import cn.com.qmth.examcloud.core.oe.admin.dao.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.admin.dao.ExamStudentRepo;
import cn.com.qmth.examcloud.core.oe.admin.dao.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.admin.dao.entity.ExamStudentEntity;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamRecordForMarkingService;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamScoreObtainQueueService;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamScorePushQueueService;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamStudentService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examstudent.ExamStudentInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.cache.ExamStudentCache;
import cn.com.qmth.examcloud.global.api.HandleSyncCloudService;
import cn.com.qmth.examcloud.global.api.request.*;
import cn.com.qmth.examcloud.global.api.response.*;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import com.google.common.collect.Lists;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description 同步考试相关数据接口
 * @Author lideyin
 * @Date 2019/12/20 10:32
 * @Version 1.0
 */
@Api(tags = "同步考试相关数据接口")
@RestController
@RequestMapping("${$rmp.cloud.oe}/exam/sync")
public class SyncExamDataCloudServiceProvider extends ControllerSupport implements SyncExamDataCloudService {

	private static final long serialVersionUID = -25466948667789119L;

	@Autowired
	private ExamRecordForMarkingService examRecordForMarkingService;
	@Autowired
	private ExamScorePushQueueService examScorePushQueueService;
	@Autowired
	private ExamScoreObtainQueueService examScoreObtainQueueService;

	/**
	 * 同步考试记录数据
	 *
	 * @param req
	 * @return
	 */
	@ApiOperation(value = "同步考试记录相关数据")
	@PostMapping("/syncExamData")
	@Override
	public SyncExamDataResp syncExamData(@RequestBody SyncExamDataReq req) {



		Long examRecordDataId=0L;//todo 取admin服务中的考试记录id
		processAfterSyncExamData(examRecordDataId);
		return null;
	}

	private void processAfterSyncExamData(Long examRecordDataId) {
		// 保存阅卷相关数据
		examRecordForMarkingService.saveExamRecordForMarking(examRecordDataId);

		// 保存考试分数数据到推分队列
		examScorePushQueueService.saveScoreDataInfoToQueue(examRecordDataId);

		// 保存考试分数数据到分数获取队列
		examScoreObtainQueueService.saveExamScoreObtainQueue(examRecordDataId);
	}
}
