package cn.com.qmth.examcloud.core.oe.admin.dao.entity;

import javax.persistence.*;

import cn.com.qmth.examcloud.core.oe.admin.dao.enums.AuditStatus;
import cn.com.qmth.examcloud.core.oe.admin.dao.enums.DisciplineType;
import cn.com.qmth.examcloud.web.jpa.JpaEntity;


/**
 * @author chenken
 * @date 2018/8/15 10:01
 * @company QMTH
 * @description ExamAuditEntity
 */
@Entity
@Table(name = "ec_oe_exam_audit",indexes = {
        @Index(name = "IDX_E_O_E_A_001",columnList = "examRecordDataId",unique = true)
})
public class ExamAuditEntity extends JpaEntity {

    /**
     *
     */
    private static final long serialVersionUID = -6330756328920243183L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * ec_oe_exam_record_data  ID
     */
    private Long examRecordDataId;

    /**
     * 违纪类型
     */
    @Enumerated(EnumType.STRING)
    private DisciplineType disciplineType;

    /**
     * 违纪详情
     */
    private String disciplineDetail;

    /**
     * 审核人ID
     */
    private String userId;
    /**
     * 审核人姓名
     */
    private String auditUserName;
    /**
     * 审核状态
     */
    @Enumerated(EnumType.STRING)
    private AuditStatus status;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getDisciplineDetail() {
        return disciplineDetail;
    }

    public void setDisciplineDetail(String disciplineDetail) {
        this.disciplineDetail = disciplineDetail;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public AuditStatus getStatus() {
        return status;
    }

    public void setStatus(AuditStatus status) {
        this.status = status;
    }

    public Long getExamRecordDataId() {
        return examRecordDataId;
    }

    public void setExamRecordDataId(Long examRecordDataId) {
        this.examRecordDataId = examRecordDataId;
    }

    public DisciplineType getDisciplineType() {
        return disciplineType;
    }

    public void setDisciplineType(DisciplineType disciplineType) {
        this.disciplineType = disciplineType;
    }

	public String getAuditUserName() {
		return auditUserName;
	}

	public void setAuditUserName(String auditUserName) {
		this.auditUserName = auditUserName;
	}
    
}
